<?php
/*
  $Id: thubservice.php$
  for ecommercetemplates
  
  Implemented by
  Atandra Systems
  www.atandra.com
  
  Copyright (c) 2006 www.atandra.com
  Released under the GNU General Public License
*/
 // print("<html> asadsad");

  DEFINE(__ENCODE_RESPONSE, true);

  DEFINE(__DEBUG, 1);
  DEFINE(__LANGUAGE_ID, 1);
  DEFINE(__DELIVERED_STATUS_ID, 3);
  DEFINE(__DELIVERED_STATUS_NAME, 'Delivered');
  
  DEFINE(__PROCESSING_STATUS_ID, 2);
  DEFINE(__PROCESSING_STATUS_NAME, 'Processing');

  //header("Content-type: application/xml");
  error_reporting(E_ALL & ~E_NOTICE);
  //  error_reporting(E_ALL);
  if (!isset($request)) {
    if (isset($_POST))
      $request = $_POST['request'];
    else
      $request = $HTTP_POST_VARS['request'];
  }  
	include "thubsettings.php";

  include "db_conn_open.php";
  include "includes.php";
  include "inc/languageadmin.php";
  include "inc/incfunctions.php";


  $PHP_SELF = (isset($HTTP_SERVER_VARS['PHP_SELF']) ? $HTTP_SERVER_VARS['PHP_SELF'] : $HTTP_SERVER_VARS['SCRIPT_NAME']);
  mysql_connect($db_host, $db_username, $db_password) or die('Unable to connect to database server!');
  mysql_select_db($db_name) or die('Unable to select database!');
  
  
  if (empty($request)) exit;

  // parse XML Request
  $request = trim(stripcslashes($request));
  
  if (__DEBUG) _log($request, __line__);
  
  // print($request);
  $xmlRequest = new xml_doc($request);
  if (__DEBUG){
    ob_start();
    print("(xml parse error):");
    $xmlRequest->parse();
    _log(ob_get_contents(), __line__);
    @ob_end_clean();
  }
  
  $xmlRequest->getTag(0, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
  //$xmlRequest->getChildByName(0, "REQUEST")
  // print($_tagName);
  // print_r($_tagTags);
  
  if (strtoupper(trim($_tagName)) != 'REQUEST') {
    print(xmlErrorResponse('unknown', '9999', 'Unknown request', STORE_NAME, ''));flush;exit;
  }
  if (count($_tagTags) == 0) {
    print(xmlErrorResponse('unknown', '9999', 'REQUEST tag doesnt have necessry parameters', STORE_NAME, ''));flush;exit;
  }
  
  $RequestParams = Array();
  foreach ($_tagTags as $k=>$v){
    $xmlRequest->getTag($v, $tN, $tA, $tC, $tT);
    $RequestParams[strtoupper($tN)] = trim($tC);
  }
  
  if (!isset($RequestParams['COMMAND'])) {
    print(xmlErrorResponse('unknown', '9999', 'Command is not set', STORE_NAME, '')); exit;
  }
  $RequestParams['COMMAND'] = strtoupper($RequestParams['COMMAND']);
  
  // print($RequestParams['COMMAND']);
  if(
         ($RequestParams['COMMAND'] != ('GET'.'ORDERS')) 
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS')) 
      // && ($RequestParams['COMMAND'] != ('UPDATE'.'INVENTORY'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'.'SHIPPING'.'STATUS'))
      // && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'.'PAYMENT'.'STATUS'))
    ) {
        print(xmlErrorResponse('unknown', '9999', 'Unknown Command'.$RequestParams['COMMAND'], STORE_NAME, ''));exit;
  }
  if (isset($RequestParams['REQUESTID'])) $request_id = $RequestParams['REQUESTID'];


  $sql_str = "SELECT adminPassword, adminVersion, adminStoreURL FROM admin WHERE adminUser='".$RequestParams['USERID']."'";
  $orders_query = mysql_query($sql_str);
  $row = mysql_fetch_array($orders_query);
  $is_authenticated = false;
  if($row){
    $is_authenticated = $RequestParams['PASSWORD'] == $row['adminPassword'];
    define(STORE_NAME, $row['adminStoreURL']);
    define(STORE_NAME_ID, $row['adminStoreURL']);
  }
  if (!$is_authenticated){
    print(xmlErrorResponse($RequestParams['COMMAND'], '9000', 'Order download service authentication failure - Login/Password supplied did not match', STORE_NAME, ''));
    exit;
  }
  
  
  
  if (isset($RequestParams['LIMITORDERCOUNT']))
    define(QB_ORDERS_PER_RESPONSE, $RequestParams['LIMITORDERCOUNT']);
  else 
    define(QB_ORDERS_PER_RESPONSE, 25);

  if (isset($RequestParams['NUMBEROFDAYS']))
    define(QB_NUMBER_OF_DAYS, $RequestParams['NUMBEROFDAYS']);
  else 
    define(QB_NUMBER_OF_DAYS, 5);

  if (isset($RequestParams['ORDERSTARTNUMBER']))
    define(QB_ORDER_START_NUMBER, $RequestParams['ORDERSTARTNUMBER']);
  else 
    define(QB_ORDER_START_NUMBER, 0);
    
  if (isset($RequestParams['EXCLUDE-ORDERS'])) {
    $exclude_orders = trim($RequestParams['EXCLUDE-ORDERS']);
    if (empty($exclude_orders)) unset($exclude_orders);
  }



  /* $xmlResponse = new xml_doc('<?xml version="1.0" encoding="UTF-8"?>'); */
  $xmlResponse = new xml_doc();
  $xmlResponse->version='1.0';
  $xmlResponse->encoding='ISO-8859-1';
  //$xmlResponse->encoding='UTF-8';
  
  $root = $xmlResponse->createTag("RESPONSE", array('Version'=>'4.1'));
  $envelope = $xmlResponse->createTag("Envelope", array(), '', $root);
  $xmlResponse->createTag("Command", array(), $RequestParams['COMMAND'], $envelope);

  switch ($RequestParams['COMMAND']){
  
    //***************************************************
    //
    //      get  Orders Service
    //
    //***************************************************  
    
    case 'GETORDERS' : {
      if (isset($request_id)) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
      $xmlResponse->createTag("StoreID",   array(), STORE_NAME, $envelope);
      $xmlResponse->createTag("StoreName", array(), STORE_NAME, $envelope);

		 	$str_date_filter = "";
		 	if (QB_ORDER_START_NUMBER == 0) {
		 		$str_date_filter = " AND to_days(Now()) - TO_DAYS(o.ordDate) <= ".QB_NUMBER_OF_DAYS;
			}

    
//      $sql_str = "
//        SELECT 
//          COUNT(*) cnt 
//        FROM orders o
//        WHERE 
//             o.ordID >".QB_ORDER_START_NUMBER."
//	       AND to_days(Now()) - TO_DAYS(ordDate) < ".$number_of_days."
//				AND o.ordStatus = 3
//       ".(QB_ORDERS_PER_RESPONSE>0?"LIMIT 0, ".QB_ORDERS_PER_RESPONSE:'');
        
      $sql_str = "
        SELECT 
          COUNT(*) cnt 
        FROM orders o
        WHERE 
             o.ordID >".QB_ORDER_START_NUMBER."
         ".$str_date_filter."
				AND o.ordStatus IN (".$orderDownloadStatusList.")
        ".(QB_ORDERS_PER_RESPONSE>0?"LIMIT 0, ".QB_ORDERS_PER_RESPONSE:'');
        
        
        
      // print($sql_str);
      $orders_query = mysql_query($sql_str);
      $row = mysql_fetch_array($orders_query);
      $no_orders = false;
      if ($row['cnt']==0) {
        $no_orders = true;
      }
    
      $xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
      $xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
      
      if ($no_orders){
        print($xmlResponse->generate()); flush; exit;
      }
      $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);

      // include(DIR_WS_CLASSES . 'order.php');
      //o.ordID, o.ordSessionID, o.ordShipExtra1, o.ordShipExtra2, o.ordExtra1, o.ordExtra2, o.ordName, o.ordAddress, o.ordCity, o.ordState, o.ordZip, o.ordCountry, o.ordEmail, o.ordPhone, o.ordShipName, o.ordShipAddress, o.ordShipCity, o.ordShipState, o.ordShipZip, o.ordShipCountry, o.ordAuthNumber, o.ordAffiliate, o.ordPayProvider, o.ordShipping, o.ordStateTax, o.ordCountryTax, o.ordHandling, o.ordShipType, o.ordTotal, o.ordDate, o.ordIP, o.ordDiscount, o.ordDiscountText, o.ordAddInfo, o.ordCNum, o.ordComLoc, o.ordStatus, o.ordStatusDate, o.ordStatusInfo,  o.ordHSTTax, o.ordTransID, o.ordAddress2, o.ordShipAddress2, o.ordTrackNum, o.ordAVS, o.ordCVV, o.ordInvoice, o.ordShipCarrier, o.ordClientID, o.ordShipPhone, o.ordCheckoutExtra1, o.ordCheckoutExtra2, o.ordAuthStatus ,
      $orders_query_raw = "
        SELECT 
          o.*, 
          os.statPrivate,
		  pp.payProvName
        FROM orders o 
        LEFT JOIN orderstatus os ON o.ordStatus = os.statID 
		LEFT JOIN payprovider pp ON pp.payProvID = o.ordPayProvider
        WHERE 
             ordID >".QB_ORDER_START_NUMBER."
         ".$str_date_filter."
		 AND o.ordStatus IN (".$orderDownloadStatusList.")
        ORDER BY ordID 
        ".(QB_ORDERS_PER_RESPONSE>0?" LIMIT 0, ".QB_ORDERS_PER_RESPONSE:'');
      // print($orders_query_raw);
    
      $orders_query = mysql_query($orders_query_raw);
      while ($orders = mysql_fetch_array($orders_query)) {
        $oInfo = parseSpecCharsA($orders);
        //var_dump($oInfo);
        // $oInfo = parseSpecChars($oInfo);
        
        $orderNode  = $xmlResponse->createTag("Order",  array(), '', $ordersNode);
        $itemsNode  = $xmlResponse->createTag("Items",  array(), '', $orderNode);
        $billNode  = $xmlResponse->createTag("Bill",    array(), '', $orderNode);
        $shipNode  = $xmlResponse->createTag("Ship",    array(), '', $orderNode);
        $chargesNode  = $xmlResponse->createTag("Charges", array(), '', $orderNode);
          
        // Orders/Order info
        $xmlResponse->createTag("OrderID",  array(), $oInfo->ordID,     $orderNode);
        $xmlResponse->createTag("_Status",   array(), $oInfo->statPrivate, $orderNode); 
        $xmlResponse->createTag("_StatusID", array(), $oInfo->ordStatus, $orderNode); 
        $xmlResponse->createTag("Date",     array(), date("Y-m-d",strtotime($oInfo->ordDate)), $orderNode); //date
        $xmlResponse->createTag("Time",     array(), date("H-i-s",strtotime($oInfo->ordDate)), $orderNode); //time
        $xmlResponse->createTag("TimeZone", array(), 'PST',                 $orderNode);
        $xmlResponse->createTag("StoreId",  array(), STORE_NAME_ID,        $orderNode);
        $xmlResponse->createTag("StoreName",array(), STORE_NAME,           $orderNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Currency", array(), $oInfo->currency,           $orderNode);
        if (!empty($oInfo->comments)) $xmlResponse->createTag("Comment",  array(), $oInfo->comments,      $orderNode, __ENCODE_RESPONSE);
        if (!empty($oInfo->ordAddInfo)) $xmlResponse->createTag("Comment",  array(), $oInfo->ordAddInfo,      $orderNode, __ENCODE_RESPONSE);
          

        // Orders/Bill info
        $xmlResponse->createTag("PayMethod",array(), $oInfo->payProvName,   $billNode, __ENCODE_RESPONSE);

				//ECT Older versions
        //$xmlResponse->createTag("FirstName",array(), strtok($oInfo->ordName, " "),   $billNode, __ENCODE_RESPONSE);
				//$xmlResponse->createTag("LastName", array(), strtok(" ")." ".strtok(" ")." ".strtok(" "),   $billNode, __ENCODE_RESPONSE);         
				//ECT v5.7.1
        $xmlResponse->createTag("FirstName", array(), $oInfo->ordName,   $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("LastName", array(), $oInfo->ordLastName,   $billNode, __ENCODE_RESPONSE);



        //$xmlResponse->createTag("CompanyName",array(), '',   $billNode);
        if ($thub_company_field != "") {
					$xmlResponse->createTag("CompanyName",array(), $oInfo->$thub_company_field,   $billNode, __ENCODE_RESPONSE);
        } else {
					$xmlResponse->createTag("CompanyName",array(), '',   $billNode, __ENCODE_RESPONSE);
        }
        
        $xmlResponse->createTag("Address1", array(), $oInfo->ordAddress,   $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Address2", array(), $oInfo->ordAddress2,   $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("City",     array(), $oInfo->ordCity,      $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("State",    array(), $oInfo->ordState,     $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Zip",      array(), $oInfo->ordZip,       $billNode);
        $xmlResponse->createTag("Country",  array(), $oInfo->ordCountry,   $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Email",    array(), $oInfo->ordEmail,     $billNode);
        $xmlResponse->createTag("Phone",    array(), $oInfo->ordPhone,     $billNode);

        //$xmlResponse->createTag("PONumber",    array(), $oInfo->ordCNum,     $billNode);




        //if (!empty($oInfo->cc_type) || (!empty($oInfo->cc_number))){
          $creditCard = $xmlResponse->createTag("CreditCard",  array(), '',   $billNode);
          
          // Orders/Bill/CreditCard info
          $xmlResponse->createTag("CreditCardType",     array(), $oInfo->cc_type,       $creditCard);
          $xmlResponse->createTag("CreditCardCharge",   array(), $oInfo->orders_total,  $creditCard);
          $xmlResponse->createTag("ExpirationDate",     array(), $oInfo->cc_expires,    $creditCard);
          $xmlResponse->createTag("CreditCardName",     array(), $oInfo->cc_owner,       $creditCard, __ENCODE_RESPONSE);
          $xmlResponse->createTag("CreditCardNumber",   array(), $oInfo->ordCNum,     $creditCard, __ENCODE_RESPONSE);
          
        //}

        // Orders/Ship info
        $xmlResponse->createTag("ShipMethod",array(), $oInfo->ordShipType,   $shipNode, __ENCODE_RESPONSE);

				//ECT Older versions
        //$xmlResponse->createTag("FirstName",array(), strtok($oInfo->ordShipName, " "),   $shipNode, __ENCODE_RESPONSE);
				//$xmlResponse->createTag("LastName", array(), strtok(" ")." ".strtok(" ")." ".strtok(" "),   $shipNode, __ENCODE_RESPONSE);         
				//ECT v5.7.1
        $xmlResponse->createTag("FirstName", array(), $oInfo->ordShipName,   $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("LastName", array(), $oInfo->ordShipLastName,   $shipNode, __ENCODE_RESPONSE);



        // $xmlResponse->createTag("CompanyName",array(), $oInfo->delivery_company,   $shipNode);
        if ($thub_shipcompany_field != "") {
					$xmlResponse->createTag("CompanyName",array(), $oInfo->$thub_shipcompany_field,   $shipNode, __ENCODE_RESPONSE);
        } else {
					$xmlResponse->createTag("CompanyName",array(), '',   $shipNode, __ENCODE_RESPONSE);
        }

        $xmlResponse->createTag("Address1", array(), $oInfo->ordShipAddress,   $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Address2", array(), $oInfo->ordShipAddress2,   $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("City",     array(), $oInfo->ordShipCity,     $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("State",    array(), $oInfo->ordShipState,    $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Zip",      array(), $oInfo->ordShipZip, $shipNode);
        $xmlResponse->createTag("Country",  array(), $oInfo->ordShipCountry,  $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Email",    array(), $oInfo->ordEmail,    $shipNode);
        $xmlResponse->createTag("Phone",    array(), $oInfo->ordPhone,    $shipNode);


        // get items of order
        // --------------------
        //$items_query_raw = "SELECT * FROM cart WHERE cartOrderID = ".$oInfo->ordID;
        $items_query_raw = "SELECT c.*, p.pWeight FROM cart as c, products as p WHERE c.cartProdID = p.pID AND cartOrderID = ".$oInfo->ordID;
        
        $items_query = mysql_query($items_query_raw);
        while ($items = mysql_fetch_array($items_query)) {
          $iInfo = parseSpecCharsA($items);
          $iInfo = parseSpecChars($iInfo);
          // print_r($iInfo);
          $itemNode = $xmlResponse->createTag("Item",    array(), '',    $itemsNode);
          
          $itemsa_query_raw = "SELECT * 
			FROM cart c
			LEFT JOIN cartoptions co ON c.cartID = co.coCartID
			WHERE cartID='".$iInfo->cartID."'";
          $itemsa_query = mysql_query($itemsa_query_raw);
          $cartPriceDiff = 0;
          while ($itemsa = mysql_fetch_array($itemsa_query)) {
            $iaInfo = parseSpecCharsA($itemsa);
            $iaInfo = parseSpecChars($iaInfo);
            // print_r($iaInfo);
            if (!isset($itemOptionsNode)) $itemOptionsNode  = $xmlResponse->createTag("ItemOptions",    array(), '',     $itemNode);
              //$xmlResponse->createTag("ItemOption", array('Name'=> htmlspecialchars(strip_tags($iaInfo->coOptGroup)),'Value'=>base64_encode(htmlspecialchars(strip_tags($iaInfo->coCartOption)))),'',$itemOptionsNode);
              $xmlResponse->createTag("ItemOption", array('Name'=> htmlspecialchars(strip_tags($iaInfo->coOptGroup)),'Value'=>htmlspecialchars(strip_tags($iaInfo->coCartOption))),'',$itemOptionsNode, __ENCODE_RESPONSE);
							$cartPriceDiff+=$iaInfo->coPriceDiff;
          }
		  
          $xmlResponse->createTag("ItemCode",       array(), $iInfo->cartProdID, $itemNode, __ENCODE_RESPONSE);
          $xmlResponse->createTag("ItemDescription",array(), $iInfo->cartProdName,      $itemNode, __ENCODE_RESPONSE);
          // $xmlResponse->createTag("ItemDescription",array(), $iInfo->cartDescription,      $itemNode);
          $xmlResponse->createTag("Quantity",       array(), $iInfo->cartQuantity,  $itemNode);
          $xmlResponse->createTag("UnitPrice",      array(), $iInfo->cartProdPrice+$cartPriceDiff,        $itemNode);
          $xmlResponse->createTag("ItemTotal",      array(), ($iInfo->cartProdPrice+$cartPriceDiff)*$iInfo->cartQuantity,        $itemNode);
          
          $xmlResponse->createTag("ItemUnitWeight",      array(), $iInfo->pWeight,   $itemNode);
          
          
          unset($itemOptionsNode);
		  
        } // end items
        
       // $xmlResponse->createTag("Tax",      array(), $oInfo->ordStateTax ,      $chargesNode); 
        $xmlResponse->createTag("Tax",      array(), $oInfo->ordStateTax + $oInfo->ordCountryTax,      $chargesNode); 
		//if ($oInfo->ordCountryTax)
		//	$xmlResponse->createTag("TaxOther",      array(), $oInfo->ordCountryTax,      $chargesNode); 
        $xmlResponse->createTag("Shipping", array(), $oInfo->ordShipping,      $chargesNode); 
        $xmlResponse->createTag("Handling", array(), $oInfo->ordHandling,      $chargesNode); 
		$xmlResponse->createTag("Discount",    array(), $oInfo->ordDiscount,      $chargesNode); 
        $xmlResponse->createTag("Total",    array(), $oInfo->ordTotal+$oInfo->ordHandling+$oInfo->ordShipping+$oInfo->ordCountryTax+$oInfo->ordStateTax-$oInfo->ordDiscount,      $chargesNode); 
      } //orders
      // print("asdas");
      
    } break;  // end of get Orders Service


    //***************************************************
    //
    //      update  Orders Shipping Status Service
    //
    //***************************************************
    
    case 'UPDATEORDERSSHIPPINGSTATUS' : {
      $ordersTag = $xmlRequest->getChildByName(0, "ORDERS");
      $xmlRequest->getTag($ordersTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
      if (count($_tagTags) == 0) $no_orders = true; else $no_orders = false;
      $xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
      $xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
      if ($no_orders){
        print($xmlResponse->generate()); exit;
      }
      
      $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
      foreach($_tagTags as $k=>$v){
        $xmlRequest->getTag($v, $_tagName, $_tagAttributes, $_tagContents, $_orderTags);
        $orderNode = $xmlResponse->createTag("Order",  array(), '',     $ordersNode);
        
        foreach($_orderTags as $k1=>$v1){
          $xmlRequest->getTag($v1, $_tagName, $_tagAttributes, $_tagContents, $_tempTags);
          $order[strtoupper($_tagName)] = $_tagContents;
          if (strtoupper($_tagName)=='HOSTORDERID')
            $xmlResponse->createTag($_tagName,  array(), $_tagContents,     $orderNode);
          if (strtoupper($_tagName)=='LOCALORDERID')
            $xmlResponse->createTag($_tagName,  array(), $_tagContents,     $orderNode);
        }


				$carrierType = "0";
				$shipVia = strtoupper ($order['SHIPPEDVIA']);
				if ($shipVia == "UPS"){
					$carrierType = "4";
				} elseif ($shipVia == "USPS") { 
					$carrierType = "3";
				} elseif ($shipVia == strtoupper("FedEx")) { 
					$carrierType = "7";
				} elseif ($shipVia == strtoupper("DHL")) { 
					$carrierType = "8";
				}			

        
        $query = mysql_query("SELECT count(*) cnt FROM orders WHERE ordID = '".$order['HOSTORDERID']."'");
        $row = mysql_fetch_array($query);

        $result = 'Success';
        $shipInfo ="";
        if ($row['cnt']==0) 
        	$result = 'Order not found';
        else 
          $shipInfo = $order['SERVICEUSED'];
        
        //if ($row['cnt']==0) $result = 'Order not found';
          $updateQuery = "
            UPDATE orders 
            SET 
              ordStatus = ".$orderShippedStatus.",
              ordShipCarrier = ".$carrierType.",
              ordShipType = '".$shipInfo."',
              ordTrackNum = '".$order['TRACKINGNUMBER']."'
            WHERE ordID = ".$order['HOSTORDERID'];
         // if(!db_query($updateQuery)) $result = 'Failed';
          mysql_query($updateQuery);
        $xmlResponse->createTag('HostStatus',  array(), $result, $orderNode);
      }
      
      
    } break;  // end of update Orders Shipping Status Service



    
  } // end of command case

  header("Content-type: application/xml");
  print($xmlResponse->generate());

  // print_r($RequestParams);
  // print_r($xmlRequest);

function xmlErrorResponse($command, $code, $message, $provider, $request_id='') {
  header("Content-type: application/xml");
  $xmlResponse = new xml_doc('<?xml version="1.0" encoding="UTF-8"?>');
  //$xmlResponse = new xml_doc();
  //$xmlResponse->version='';
 // $xmlResponse->encoding='UTF-8';
  $root = $xmlResponse->createTag("RESPONSE", array('Version'=>'1.0'));
  //print("i'm here");
  $envelope = $xmlResponse->createTag("Envelope", array(), '', $root);
  $xmlResponse->createTag("Command", array(), $command, $envelope);
  $xmlResponse->createTag("StatusCode", array(), $code, $envelope);
  $xmlResponse->createTag("StatusMessage", array(), $message, $envelope);
  //if ($request_id) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
  //$xmlResponse->createTag("Provider", array(), $provider, $envelope);
  return $xmlResponse->generate();
}

function parseTagName($str) {
  return preg_replace("/[-=+\s!@#\$\^\&%*\(\)\{\}\[\]':`~\.]/is", "", $str);
}

function parseSpecChars($obj) {
  foreach($obj as $k=>$v){
    $obj->$k = htmlspecialchars($v, ENT_NOQUOTES); 
  }
  return $obj;
}


function parseSpecCharsA($arr){
//  $obj='';
  foreach($arr as $k=>$v){
    $obj->$k = htmlspecialchars($v, ENT_NOQUOTES); 
  }
  return $obj;
}

function _log($text, $line) {
  //disabling log for production
  //$filename = "_log.txt";
  //$df =  fopen($filename, "a");
  //$str = date("m-d-Y | H:i:s ($line) ");
  //fwrite($df, $str.$text."\n");
  //fclose($df);
}



// ##########################################################################################################################################

  
    //***************************************************
    //
    //      XML Class Declaration
    //
    //***************************************************  
    
// ____________________________________________________________________________________________________________________________________________



class xml_doc {
	var $parser;			// Object Reference to parser
	var $xml;				// Raw XML code
	var $version;			// XML Version
	var $encoding;			// Encoding type
	var $dtd;				// DTD Information
	var $entities;			// Array (key/value set) of entities
	var $xml_index;			// Array of object references to XML tags in a DOC
	var $xml_reference;		// Next available Reference ID for index
	var $document;			// Document tag (type: xml_tag)
	var $stack;			// Current object depth (array of index numbers)

	function xml_doc($xml='') {
		// XML Document constructor


		$this->xml = $xml;

		// Set default values
		$this->version = '1.0';
	  $this->encoding = "ISO-8859-1";
		//$this->encoding = "UTF-8";
		$this->dtd = '';
		$this->entities = array();
		$this->xml_index = array();
		$this->xml_reference = 0;
		$this->stack = array();
	}

	function parse() {
		// Creates the object tree from XML code


		$this->parser = xml_parser_create($this->encoding);
		xml_set_object($this->parser, $this);
		xml_set_element_handler($this->parser, "startElement", "endElement");
		xml_set_character_data_handler($this->parser, "characterData");
		xml_set_default_handler($this->parser, "defaultHandler");

		if (!xml_parse($this->parser, $this->xml)) {
			// Error while parsing document

			$err_code = xml_get_error_code($this->parser);
			$err_string = xml_error_string($this->parser);
			$err_line = xml_get_current_line_number($this->parser);
			$err_col = xml_get_current_column_number($this->parser);
			$err_byte = xml_get_current_byte_index($this->parser);
			print "<p><b>Error Code:</b> $err_code<br>$err_string<br><b>Line:</b> $err_line <b>Column:</b> $err_col</p>";
		}

		xml_parser_free($this->parser);
	}

	function generate() {
		// Generates XML string from the xml_doc::document object


		// Create document header
		if ($this->version == '' and $this->encoding == '') {
			// $out_header = '<' . '?xml ?' . ">\n";
			$out_header = '';
		} elseif ($this->version != '' and $this->encoding == '') {
			$out_header = '<' . "?xml version=\"{$this->version}\"?" . ">\n";
		} else {
			$out_header = '<' . "?xml version=\"{$this->version}\" encoding=\"{$this->encoding}\"?" . ">\n";
		}

		if ($this->dtd != '') {
			$out_header .= "<!DOCTYPE " . $this->dtd . ">\n";
		}

		// Get reference for root tag
		$_root =& $this->xml_index[0];

		// Create XML for root tag
		$this->xml = $this->createXML(0);

		return $out_header . $this->xml;
	}

	function stack_location() {
		// Returns index for current working tag


		return $this->stack[(count($this->stack) - 1)];
	}

	function startElement($parser, $name, $attrs=array()) {
		// Process a new tag


		// Check to see if tag is root-level
		if (count($this->stack) == 0) {
			// Tag is root-level (document)

			$this->document = new xml_tag($this,$name,$attrs);
			$this->document->refID = 0;

			$this->xml_index[0] =& $this->document;
			$this->xml_reference = 1;

			$this->stack[0] = 0;

		} else {
			// Get current location in stack array
			$parent_index = $this->stack_location();

			// Get object reference to parent tag
			$parent =& $this->xml_index[$parent_index];

			// Add child to parent
			$parent->addChild($this,$name,$attrs);

			// Update stack
			array_push($this->stack,($this->xml_reference - 1));
		}

	}

	function endElement($parser, $name) {
		// Update stack


		array_pop($this->stack);
	}

	function characterData($parser, $data) {
		// Add textual data to the current tag


		// Get current location in stack array
		$cur_index = $this->stack_location();

		// Get object reference for tag
		$tag =& $this->xml_index[$cur_index];

		// Assign data to tag
		$tag->contents .= $data;
	}

	function defaultHandler($parser, $data) {

	}

	function createTag($name, $attrs=array(), $contents='', $parentID = '', $encode = false) {

		// Creates an XML tag, returns Tag Index #

		if ($encode) {
			$contents = base64_encode(trim($contents));
			foreach ($attrs as $k=>$v){
				$attrs[$k] = base64_encode($v);
			}
			$attrs['encoding'] = "yes";
		}
		if ($parentID === '') {
			// Tag is root-level
			$this->document = new xml_tag($this,$name,$attrs,$contents);
			$this->document->refID = 0;
			$this->xml_index[0] =& $this->document;
			$this->xml_reference = 1;
			return 0;
		} else {
			// Tag is a child
			// Get object reference to parent tag
			$parent =& $this->xml_index[$parentID];
			// Add child to parent
			return $parent->addChild($this,$name,$attrs,$contents);
		}
	}


	function createTag1($name, $attrs=array(), $contents='', $parentID = '') {
		// Creates an XML tag, returns Tag Index #


		if ($parentID === '') {
			// Tag is root-level

			$this->document = new xml_tag($this,$name,$attrs,$contents);
			$this->document->refID = 0;

			$this->xml_index[0] =& $this->document;
			$this->xml_reference = 1;

			return 0;
		} else {
			// Tag is a child

			// Get object reference to parent tag
			$parent =& $this->xml_index[$parentID];
			// Add child to parent
			return $parent->addChild($this,$name,$attrs,$contents);
		}
	}


	function createXML($tagID,$parentXML='') {
		// Creates XML string for a tag object
		// Specify parent XML to insert new string into parent XML


		$final = '';

		// Get Reference to tag object
		$tag =& $this->xml_index[$tagID];

		$name = $tag->name;
		$contents = $tag->contents;
		$attr_count = count($tag->attributes);
		$child_count = count($tag->tags);
		$empty_tag = ($tag->contents == '') ? true : false;

		// Create intial tag
		if ($attr_count == 0) {
			// No attributes

			if ($empty_tag === true) {
					$final = "<$name />";
			} else {
					$final = "<$name>$contents</$name>";
			}
		} else {
			// Attributes present

			$attribs = '';
			foreach ($tag->attributes as $key => $value) {
				$attribs .= ' ' . $key . "=\"$value\"";
			}

			if ($empty_tag === true) {
				$final = "<$name$attribs />";
			} else {
				$final = "<$name$attribs>$contents</$name>";
			}
		}

		// Search for children
		if ($child_count > 0) {
			foreach ($tag->tags as $childID) {
				$final = $this->createXML($childID,$final);
			}
		}

		if ($parentXML != '') {
			// Add tag XML to parent XML

			$stop1 = strrpos($parentXML,'</');
			$stop2 = strrpos($parentXML,' />');

			if ($stop1 > $stop2) {
				// Parent already has children

				$begin_chunk = substr($parentXML,0,$stop1);
				$end_chunk = substr($parentXML,$stop1,(strlen($parentXML) - $stop1 + 1));

				$final = $begin_chunk . $final . $end_chunk;
			} elseif ($stop2 > $stop1) {
				// No previous children

				$spc = strpos($parentXML,' ',0);

				$parent_name = substr($parentXML,1,$spc - 1);

				if ($spc != $stop2) {
					// Attributes present
					$parent_attribs = substr($parentXML,$spc,($stop2 - $spc));
				} else {
					// No attributes
					$parent_attribs = '';
				}

				$final = "<$parent_name$parent_attribs>$final</$parent_name>";
			}
		}

		return $final;
	}


	function getTag($tagID,&$name,&$attributes,&$contents,&$tags) {
		// Returns tag information via variable references from a tag index#


		// Get object reference for tag
		$tag =& $this->xml_index[$tagID];

		$name = $tag->name;
		$attributes = $tag->attributes;
		$contents = $tag->contents;
		$tags = $tag->tags;
	}

	function getChildByName($parentID,$childName,$startIndex=0) {
		// Returns child index# searching by name


		// Get reference for parent
		$parent =& $this->xml_index[$parentID];

		if ($startIndex > count($parent->tags)) return false;


		for ($i = $startIndex; $i < count($parent->tags); $i++) {
			$childID = $parent->tags[$i];		

			// Get reference for child
			$child =& $this->xml_index[$childID];

			if ($child->name == $childName) {
				// Found child, return index#

				return $childID;
			}
		}
	}

}


class xml_tag {

	var $refID;			// Unique ID number of the tag
	var $name;			// Name of the tag
	var $attributes = array();	// Array (assoc) of attributes for this tag
	var $tags = array();		// An array of refID's for children tags
	var $contents;			// textual (CDATA) contents of a tag
	var $children = array();	// Collection (type: xml_tag) of child tag's


	function xml_tag(&$document,$tag_name,$tag_attrs=array(),$tag_contents='') {
		// Constructor function for xml_tag class


		// Set object variables
		$this->name = $tag_name;
		$this->attributes = $tag_attrs;
		$this->contents = $tag_contents;

		$this->tags = array();			// Initialize children array/collection
		$this->children = array();
	}

	function addChild (&$document,$tag_name,$tag_attrs=array(),$tag_contents='') {
		// Adds a child tag object to the current tag object


		// Create child instance
		$this->children[(count($this->children))] = new xml_tag($document,$tag_name,$tag_attrs,$tag_contents);

		// Add object reference to document index
		$document->xml_index[$document->xml_reference] =& $this->children[(count($this->children) - 1)];

		// Assign document index# to child
		$document->xml_index[$document->xml_reference]->refID = $document->xml_reference;

		// Add child index# to parent collection of child indices
		array_push($this->tags,$document->xml_reference);

		// Update document index counter
		$document->xml_reference++;

		// Return child index#
		return ($document->xml_reference - 1);
	}
}


?>

